/*
 * queue.h
 *
 *  Created on: 10 mai 2021
 *      Author: Florian
 */

#ifndef INC_QUEUE_H_
#define INC_QUEUE_H_

/* Includes */
#include "common.h"
#include "string.h"

/* Constants */
#define cQueueElementsMax 16 		// Maximum number of elements in the queue

/* Typedefs */

/* Main queue element */
typedef struct tQueue_Element tQueue_Element;
struct tQueue_Element
{
	void *item_p;

	tQueue_Element *next_p;
	tQueue_Element *prev_p;
};

/* Head of the queue */
typedef struct
{
	tQueue_Element *element;
}tQueue_List;

/* Shared functions */

/* --------------------------------------------
 * Init, start and stop of the module
 * Params : -
 * Return : -
 ---------------------------------------------- */
void Queue_Init (void);
void Queue_Start (void);
void Queue_Stop (void);

/* --------------------------------------------
 * Adds/removes an item to/from the queue - creates an element
 * Params : element_p, pointer to the element to be added
 * Return : -
 ---------------------------------------------- */
BOOL Queue_Enqueue(void **item_p);
BOOL Queue_Dequeue(void **item_p);

#endif /* INC_QUEUE_H_ */
