/*
 * timemgt.h
 *
 *  Created on: Apr 28, 2021
 *      Author: Florian
 */

#ifndef INC_TIMEMGT_H_
#define INC_TIMEMGT_H_

/* Includes */
#include "common.h"

/* Constants */
#define cTimeMgtAlarmsNumber 8
#define TIM_ChannelNumberMax_U8 ((uint8_t)8)
#define cTimeMgtTagStringMaxLength 8

#define cTimeMgtChannelMax 8

/* Typedefs */
typedef void (* pTimeMgtCallback)(void);

typedef struct tTimeMgt_Channel tTimeMgt_Channel;
struct tTimeMgt_Channel
{
	uint32_t timeout_u32;
	uint32_t counter_u32;
	uint32_t cycles_u32;
	BOOL repeat_b;
	BOOL enable_b;
	pTimeMgtCallback callback_p;
};

typedef struct tTimeMgt_Element tTimeMgt_Element;
struct tTimeMgt_Element
{
	void *item_p;

	uint32_t id_u32;
	char tag_u8a[cTimeMgtTagStringMaxLength];
	pTimeMgtCallback callback_p;
	tTimeMgt_Element *next_p;
	tTimeMgt_Element *prev_p;
};

//typedef struct tTimeMgt_List tTimeMgt_List;
typedef struct
{
	tTimeMgt_Element *head;
}tTimeMgt_List;

/* Shared functions */
void TimeMgt_Init (void);
void TimeMgt_Start (void);
void TimeMgt_Stop (void);

void TimeMgt_PeriodicFunction (void);

BOOL TimeMgt_AddCyclicEvent(uint8_t channel_u8, pTimeMgtCallback callback_p, uint32_t timeout_u32, char *tag_u8p, uint8_t *id_u32p);

BOOL TimeMgt_SearchEventById(uint32_t id_u32, tTimeMgt_Element** prev, tTimeMgt_Element** match);

void TimeMgt_RemoveCyclicEvent(uint8_t channel_u8);
BOOL TimeMgt_RemoveCyclicEventById(uint32_t id_u32);
BOOL TimeMgt_RemoveCyclicEventByTag(char *tag_u8p);

void TimeMgt_EnableCyclicEvent(uint8_t channel_u8);
BOOL TimeMgt_EnableCyclicEventById(uint32_t id_u32);
BOOL TimeMgt_EnableCyclicEventByTag(char *tag_u8p);

void TimeMgt_DisableCyclicEvent(uint8_t channel_u8);
BOOL TimeMgt_DisableCyclicEventById(uint32_t id_u32);
BOOL TimeMgt_DisableCyclicEventByTag(char *tag_u8p);

#endif /* INC_TIMEMGT_H_ */
