/*
 * queue.c
 *
 *  Created on: 10 mai 2021
 *      Author: Florian
 */

// TODO : CreateQueue + add parameter to queue head pointer

#include "queue.h"

/* Local static variables */
static tQueue_List head_T;
static tQueue_List tail_T;
static uint32_t element_cnt_u32; 	// Counts the number of items in the queue

static tQueue_Element *element_rover_p;

/* Local static functions */

/* Shared functions */
void Queue_Init (void)
//----------------------------------------------
{
	head_T.element = NULL;
	tail_T.element = NULL;

	element_cnt_u32 = 0U;
}

void Queue_Start (void)
//----------------------------------------------
{

}

void Queue_Stop(void)
//----------------------------------------------
{

}

BOOL Queue_Enqueue(void **item_p)
//----------------------------------------------
{
	BOOL ret_b = FALSE;

	// Chained list managed
	if (element_cnt_u32 < cQueueElementsMax)
	{
		tQueue_Element *element = malloc(sizeof(tQueue_Element));

		element->item_p = *item_p;

		if (head_T.element == NULL) // If no object present in the list
		{
			element->next_p = NULL;
			element->prev_p = NULL;
			head_T.element = element;
			tail_T.element = element;
		}
		else // If objects present in the list
		{
			element->next_p = head_T.element;
			element->prev_p = NULL;
			head_T.element->prev_p = element;
			head_T.element = element;
		}

		// Increment element counter
		element_cnt_u32++;

		ret_b = TRUE;
	}

	return (ret_b);
}

BOOL Queue_Dequeue(void **item_p)
//----------------------------------------------
{
	BOOL ret_b = FALSE;

	if (element_cnt_u32 > 1U)
	{
		*item_p = tail_T.element->item_p;
		tail_T.element = tail_T.element->prev_p;
		(tail_T.element->next_p)->prev_p = NULL;
		free(tail_T.element->next_p);
		tail_T.element->next_p = NULL;

		// Decrement element counter
		element_cnt_u32--;

		ret_b = TRUE;
	}
	else if (element_cnt_u32 == 1U) // Only one element in the queue
	{
		*item_p = tail_T.element->item_p;
		free(tail_T.element);
		tail_T.element = NULL;
		head_T.element = NULL;

		element_cnt_u32 = 0;

		ret_b = TRUE;
	}

	return ret_b;
}


